unit uBizPedidosProveedorServer;

interface

uses
  uDAInterfaces, schPedidosProveedorServer_Intf,
  uDADataTable, uDABusinessProcessor;

const
  BIZ_SERVER_PEDIDOS_PROVEEDOR = 'Server.PedidosProveedor';
  REF_PEDIDOS_PROVEEDOR = 'REF_PEDIDOS_PROVEEDOR';

type
  TBizPedidosProveedorServer = class(TPedidosProveedorBusinessProcessorRules)
  protected
    procedure BeforeProcessChange(Sender: TDABusinessProcessor;
      aChangeType: TDAChangeType; aChange: TDADeltaChange;
      var ProcessChange: Boolean); override;
  end;

implementation

uses
  Dialogs, SysUtils, Variants, uDataModuleServer, uDAClasses, DARemoteService_Impl,
  schPedidosProveedorClient_Intf, uBusinessUtils, uReferenciasUtils, uROClasses;

{ TBizPedidosProveedorServer }

procedure TBizPedidosProveedorServer.BeforeProcessChange(
  Sender: TDABusinessProcessor; aChangeType: TDAChangeType;
  aChange: TDADeltaChange; var ProcessChange: Boolean);
var
  ASchema : TDASchema;
  ACurrentConn : IDAConnection;
  dsData: IDADataset;
  Empresa : Variant;

begin
  inherited;
  case aChangeType of
    ctInsert, ctUpdate: begin
      //Si la referencia no ha sido asignada le asignamos una nosotros
      if (VarIsNull(aChange.NewValueByName[fld_PedidosProveedorREFERENCIA]))
      or (VarToStr(aChange.NewValueByName[fld_PedidosProveedorREFERENCIA]) = '') then
      begin
        ASchema := BusinessProcessor.Schema;
        ACurrentConn := GetBusinessProcessorConnection(BusinessProcessor);

        try
          //Siempre va a estar rellena
          Empresa := aChange.NewValueByName[fld_PedidosProveedorID_EMPRESA];
          dsData := ASchema.NewDataset(ACurrentConn, 'DarReferencia', ['CODIGO', 'ID_EMPRESA'], [REF_PEDIDOS_PROVEEDOR, Empresa]);
        except
          RaiseError('No existe la tabla REFERENCIAS');
        end;

        dsData.Active := True;

        if dsData.IsEmpty then
          RaiseError('NO HAY REFERENCIA ' + REF_PEDIDOS_PROVEEDOR + ' DECLARADA EN TABLA REFERENCIAS');

        REFERENCIA := dsData.FieldByName(fld_DarReferenciaVALOR).AsString;

        try
          ASchema.NewCommand(ACurrentConn, 'ModificarReferencia', ['CODIGO', 'VALOR', 'ID_EMPRESA'], [REF_PEDIDOS_PROVEEDOR, DarReferenciaSiguiente(REFERENCIA), Empresa]);
        except
          RaiseError('Error al asignar la nueva ' + REFERENCIA + ' referencia en tabla');
        end;

      end;
    end;
  end;
end;

initialization
  RegisterBusinessProcessorRules(BIZ_SERVER_PEDIDOS_PROVEEDOR, TBizPedidosProveedorServer);

end.
